/*******************************************************************
                    dct coefficient module
 *******************************************************************/
#define DCT_COEFFICIENT_C
#include "dct_coefficient.h"

void read_mpeg2_escape_dct_coefficient(VIDEO_STREAM *in, int *run, int *level);
void read_mpeg1_escape_dct_coefficient(VIDEO_STREAM *in, int *run, int *level);

void read_mpeg2_escape_dct_coefficient(VIDEO_STREAM *in, int *run, int *level)
{
	int n;
	int code;
	
	static const unsigned int sign[] = {
		0, 0xFFFFF000,
	};

	code = vs_get_bits(in, 6);

	*run = code;

	code = vs_get_bits(in, 12);
	n = code >> 11;
	code |= sign[n];
	
	*level = code;
}

void read_mpeg1_escape_dct_coefficient(VIDEO_STREAM *in, int *run, int *level)
{
	int code;
	
	code = vs_get_bits(in, 6);
	*run = code;

	code = vs_get_bits(in, 8);
	if(code == 0){
		code = vs_get_bits(in, 8);
	}else if(code==128){
		code = vs_get_bits(in, 8) - 256;
	}else if(code>128){
		code -= 256;
	}

	*level = code;
}