;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
.586
.mmx
.xmm
.model flat
_TEXT64 segment page public use32 'CODE'
		align 16

;-------------------------------------------------------------------
; 萔
;-------------------------------------------------------------------

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; chroma420i_to_422_sse2 - C^[X 420  422 ւ̕
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; (y*4+2) = ((y*2  ) * 5 + (y*2+2) * 3 )>> 3
; (y*4+3) = ((y*2+1) * 7 + (y*2+3) * 1 )>> 3
; (y*4+4) = ((y*2  ) * 1 + (y*2+2) * 7 )>> 3
; (y*4+5) = ((y*2+1) * 3 + (y*2+3) * 5 )>> 3
;-------------------------------------------------------------------
PUBLIC              C _chroma420i_to_422_sse2@12
;      void __stdcall  chroma420i_to_422_sse2(
; [esp + 4] = unsigned char *data,
; [esp + 8] = int            width,
; [esp +12] = int            height
; )
;
_chroma420i_to_422_sse2@12 PROC
;-------------------------------------------------------------------
; WX^ޔ
		push       edi
		push       esi
		push       edx
		push       ecx
		push       ebx
		push       eax
;-------------------------------------------------------------------
; p[^󂯎
		mov        esi, [esp+24+4]  ; data
		mov        edx, [esp+24+8]  ; width
		mov        eax, [esp+24+12] ; height
;-------------------------------------------------------------------
; [Jϐ̈m
		sub        esp, 12
;-------------------------------------------------------------------
; [vp[^쐬
; 
; ׂp[^
; (height/4)-1 - eax
; width        - edx
; width/16     - ecx & [esp+12]
; width*2-8    - ebx
; width/2*7    - [esp+4]
; width/2*3    - [esp+8]
; data+width/2 - edi
; all 5        - xmm7
		mov        ecx, edx
		mov        ebx, edx
		pcmpeqw    xmm7, xmm7
		pcmpeqw    xmm6, xmm6
		shr        eax, 2
		shr        ecx, 1
		shl        ebx, 1
		psrlw      xmm7, 14
		psllw      xmm6, 1
		lea        edi, [esi+ecx]
		add        ecx, edx
		dec        eax
		add        ebx, ecx
		mov        [esp+4], ebx
		mov        [esp+8], ecx
		mov        ecx, edx
		mov        ebx, edx
		shr        ecx, 4
		shl        ebx, 1
		mov        [esp+12], ecx
		psubw      xmm7, xmm6
		sub        ebx, 8
		shl        ecx, 1
;-------------------------------------------------------------------
; ԗO - gbvQŝ܂܃Rs[
		cld
		rep movsd
		mov        ecx, esi
		mov        esi, edi
		lea        edi, [ecx+edx]
		mov        ecx, [esp+12]
		shl        ecx, 1
		rep movsd
		lea        edi, [esi+edx]
		mov        esi, [esp+12+24+4]
		mov        ecx, [esp+12]
;-------------------------------------------------------------------
; c[v
chroma420i_to_422_next_4_line:
;-------------------------------------------------------------------
; [v
chroma420i_to_422_next_4_pixel:
;-------------------------------------------------------------------
; ԃRA
;
; RRł̃WX^pr
; esi - ̓AhX
; edi - o̓AhX
; edx - 
; mm7 - all 5
		movq       xmm0, [esi]      ; c[0][x]
		lea        esi, [esi+edx]
		movq       xmm1, [esi]      ; c[1][x]  
		lea        esi, [esi+edx]
		movq       xmm2, [esi]      ; c[2][x]
		movq       xmm3, [esi+edx]  ; c[3][x]
		pxor       xmm6, xmm6       ; all 0
		pcmpeqw    xmm4, xmm4
		pcmpeqw    xmm5, xmm5
		psrlw      xmm4, 14         ; all 3
		psrlw      xmm5, 13         ; all 7
		punpcklbw  xmm0, xmm6
		punpcklbw  xmm1, xmm6
		punpcklbw  xmm2, xmm6
		punpcklbw  xmm3, xmm6
		movdqa     xmm6, xmm4
		pmullw     xmm4, xmm2       ; 3*c[2][x]
		pmullw     xmm2, xmm5       ; c[2][x]*7
		pmullw     xmm5, xmm1       ; 7*c[1][x]
		pmullw     xmm1, xmm6       ; c[1][x]*3
		paddw      xmm2, xmm0       ; c[2][x]*7 + c[0][x]
		paddw      xmm5, xmm3       ; 7*c[1][x] + c[3][x]
		pmullw     xmm0, xmm7       ; c[0][x]*5
		pmullw     xmm3, xmm7       ; c[3][x]*5
		paddw      xmm0, xmm4       ; c[0][x]*5 + 3*c[2][x]
		paddw      xmm3, xmm1       ; c[3][x]*5 + c[1][x]*3
		psraw      xmm2, 3
		psraw      xmm5, 3
		psraw      xmm0, 3
		psraw      xmm3, 3
		packuswb   xmm0, xmm2
		packuswb   xmm5, xmm3
		movq       [edi], xmm0
		lea        edi, [edi+edx]
		psrldq     xmm0, 8
		movq       [edi], xmm5
		lea        edi, [edi+edx]
		psrldq     xmm5, 8
		movq       [edi], xmm0
		movq       [edi+edx], xmm5
;-------------------------------------------------------------------
; [vI[`FbN
		sub        esi, ebx
		sub        edi, ebx
		dec        ecx
		jnz        chroma420i_to_422_next_4_pixel
;-------------------------------------------------------------------
; c[vI[`FbN
		add        edi, [esp+4]
		add        esi, [esp+8]
		mov        ecx, [esp+12]
		dec        eax
		jnz        chroma420i_to_422_next_4_line
;-------------------------------------------------------------------
; ԗO - {gQŝ܂܃Rs[
		shr        edx, 1
		shl        ecx, 1
		rep movsd
		lea        esi, [esi+edx]
		lea        edi, [edi+edx]
		mov        ecx, [esp+12]
		shl        ecx, 1
		rep movsd
;-------------------------------------------------------------------
; n
		add        esp, 12          ; [Jϐ

		pop        eax              ; WX^
		pop        ebx
		pop        ecx
		pop        edx
		pop        esi
		pop        edi

		ret        12
;-------------------------------------------------------------------
_chroma420i_to_422_sse2@12 ENDP
;-------------------------------------------------------------------
; I

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; chroma420p_to_422_sse2 - vObVu 420  422 ւ̕
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; [o1] = ([i0] * 3 + [i1]) / 4
; [o2] = ([i0] + [i1] * 3) / 4
;-------------------------------------------------------------------
PUBLIC              C _chroma420p_to_422_sse2@12
;      void __stdcall  chroma420p_to_422_sse2(
; [esp + 4] = unsigned char *data,
; [esp + 8] = int            width,
; [esp +12] = int            height
; )
;
_chroma420p_to_422_sse2@12 PROC
;-------------------------------------------------------------------
; WX^ޔ
		push       edi
		push       esi
		push       edx
		push       ecx
		push       ebx
		push       eax
;-------------------------------------------------------------------
; ̃f[^󂯎
		mov        esi, [esp+24+4]
		mov        edx, [esp+24+8]
		mov        ebx, [esp+24+12]
;-------------------------------------------------------------------
; [vp[^쐬
; 
; ׂp[^
;
; data         - esi
; data+width/2 - edi
; width/2      - eax
; height/2-1   - ebx
; width        - edx
; all 3        - xmm6
; all 0        - xmm7
; 
		mov        eax, edx
		mov        ecx, edx
		shr        ebx, 1
		shr        eax, 1
		shr        ecx, 3
		pcmpeqw    xmm6, xmm6
		pxor       xmm7, xmm7
		dec        ebx
		lea        edi, [esi+eax]
		psrlw      xmm6, 14
;-------------------------------------------------------------------
; ԗO - 擪 1 sRs[
		rep movsd
		mov        ecx, edx
		sub        esi, eax
		add        edi, eax
		shr        ecx, 4
;-------------------------------------------------------------------
; c[v
chroma420p_to_422_sse2_next_2_line:
;-------------------------------------------------------------------
; [v
chroma420p_to_422_sse2_next_8_pixel:
;-------------------------------------------------------------------
; ԃRA
; 
; RRł̃p[^
; esi - ̓AhX
; edi - o̓AhX
; edx - 
; xmm6 - all 3
; xmm7 - all 0
		movq       xmm1, [esi]            ; i[0][0:7]
		movq       xmm3, [esi+edx]        ; i[1][0:7]
		lea        esi, [esi+8]
		movdqa     xmm0, xmm6
		movdqa     xmm2, xmm6
		punpcklbw  xmm1, xmm7
		punpcklbw  xmm3, xmm7
		pmullw     xmm0, xmm1
		pmullw     xmm2, xmm3
		paddw      xmm0, xmm3
		paddw      xmm1, xmm2
		psrlw      xmm0, 2
		psrlw      xmm1, 2
		packuswb   xmm0, xmm0            ; o[0][0:7]
		packuswb   xmm1, xmm1            ; o[1][0:7]
		movq       [edi], xmm0
		movq       [edi+edx], xmm1
		lea        edi, [edi+8]
;-------------------------------------------------------------------
; [vI[`FbN
		dec        ecx
		jnz        chroma420p_to_422_sse2_next_8_pixel
;-------------------------------------------------------------------
; c[vI[`FbN
		mov        ecx, edx
		add        edi, edx
		lea        esi, [esi+eax]
		lea        edi, [edi+eax]
		shr        ecx, 4
		dec        ebx
		jnz        chroma420p_to_422_sse2_next_2_line
;-------------------------------------------------------------------
; ԗO - {g 1 sRs[
		shl        ecx, 1
		rep movsd
;-------------------------------------------------------------------
; n
		pop        eax; WX^
		pop        ebx
		pop        ecx
		pop        edx
		pop        esi
		pop        edi

		ret        12
;-------------------------------------------------------------------
_chroma420p_to_422_sse2@12 ENDP
;-------------------------------------------------------------------
; I

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; yuv422_to_bgr_sse2 - YUV -> RGB ϊ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-------------------------------------------------------------------
PUBLIC              C _yuv422_to_bgr_sse2@16
;      void __stdcall  yuv422_to_bgr_sse2(
; [esp + 4] = FRAME                    *top,
; [esp + 8] = FRAME                    *bottom,
; [esp +12] = unsigned char            *out,
; [esp +16] = BGR_CONVERSION_PARAMETER *prm
; )
_yuv422_to_bgr_sse2@16 PROC
;-------------------------------------------------------------------
; gp郍[Jϐ
; 
; [esp+  8] - work
; [esp+ 32] - y_gain
; [esp+ 48] - half_13
; [esp+ 64] - bu
; [esp+ 80] - guv
; [esp+ 96] - rv
; [esp+112] - width/8
; [esp+116] - width%8*3
; [esp+120] - in_step*2
; [esp+124] - out_step
;
; total 128 + 
;-------------------------------------------------------------------
; WX^̑ޔ
		push       ebp
		push       edi
		push       esi
		push       edx
		push       ecx
		push       ebx
		push       eax
;-------------------------------------------------------------------
; x[X|C^ɃX^bNAhXL
		mov        ebp, esp
;-------------------------------------------------------------------
; [Jϐ̈̊m
		sub        esp, 128
		and        esp, 0fffffff0h
;-------------------------------------------------------------------
; ϊW̍쐬
;
; 쐬ׂp[^
;
; y_offset   - mm0
; c_offset   - mm1
; y_gain     - [esp+32]
; half_13    - [esp+48]
; bu         - [esp+64]
; guv        - [esp+80]
; rv         - [esp+96]
; y_src      - esi & mm2
; u_src      - eax & mm3
; v_src      - ebx & mm4
; y_src_next - mm5
; u_src_next - mm6
; v_src_next - mm7
; width/8    - ecx & [esp+112]
; width%8*3  - [esp+116]
; height     - edx
; in_step*2  - [esp+120]
; out_step   - [esp+124]
;
		mov        edx, [ebp+28+16]
		pcmpeqw    mm0, mm0
		pxor       xmm0, xmm0
		pxor       mm1, mm1
		pcmpeqw    xmm1, xmm1
		movd       mm2, [edx+20]  ; y_offset
		movd       xmm2, [edx+24] ; y_gain
		movd       xmm3, [edx+28] ; bu
		movd       xmm4, [edx+32] ; gu
		movd       xmm5, [edx+36] ; gv
		movd       xmm6, [edx+40] ; rv
		psubw      mm1, mm0       ; all 1
		psubd      xmm0, xmm1     ; all 1
		pshufw     mm0, mm2, 0    ; yo_yo_yo_yo
		psllw      mm1, 7         ; c_offset
		movdqa     xmm1, xmm0     ; all 1
		pshufd     xmm2, xmm2, 0  ; yg_yg_yg_yg
		pshufd     xmm3, xmm3, 0  ; bu_bu_bu_bu
		punpckldq  xmm4, xmm5     ; xx_xx_gv_gu
		pshufd     xmm6, xmm6, 0  ; rv_rv_rv_rv
		pslld      xmm0, 2        ; half_3
		pslld      xmm1, 12       ; half_13
		pshufd     xmm4, xmm4, 01000100b
		paddd      xmm2, xmm0
		paddd      xmm3, xmm0
		paddd      xmm4, xmm0
		paddd      xmm6, xmm0
		psrad      xmm2, 3
		psrad      xmm3, 3
		psrad      xmm4, 3
		psrad      xmm6, 3
		packssdw   xmm4, xmm4
		movdqa     [esp+32], xmm2
		movdqa     [esp+48], xmm1
		movdqa     [esp+64], xmm3
		movdqa     [esp+80], xmm4
		movdqa     [esp+96], xmm6
		mov        eax, [edx] ; width
		mov        ecx, [edx] ; width
		movd       mm7, [edx+8] ; in_step
		movd       mm4, [edx+16] ; c_offset
		mov        esi, [ebp+28+4] ; top
		mov        edi, [ebp+28+8] ; bottom
		punpckldq  mm7, mm7
		punpckldq  mm4, mm4
		movd       mm2, [esi+16] ; top y
		movq       mm3, [esi+20] ; top uv
		movd       mm5, [edi+16] ; bottom y
		movq       mm6, [edi+20] ; bottom uv
		shr        ecx, 3
		and        eax, 7
		paddd      mm5, mm7
		mov        ebx, eax
		paddd      mm6, mm7
		shl        eax, 1
		paddd      mm3, mm4
		add        eax, ebx
		paddd      mm6, mm4
		mov        ebx, [edx+12] ; out_step
		mov        edx, [edx+4] ; height
		pslld      mm7, 1
		mov        [esp+112], ecx
		mov        [esp+116], eax
		movd       [esp+120], mm7
		mov        [esp+124], ebx
		movq       mm4, mm3
		movq       mm7, mm6
		psrlq      mm4, 32
		psrlq      mm7, 32
		movd       esi, mm2
		movd       eax, mm3
		movd       ebx, mm4
		mov        edi, [ebp+28+12]
;-------------------------------------------------------------------
; c[v
yuv422_to_bgr_next_line:
;-------------------------------------------------------------------
; [v
yuv422_to_bgr_next_8_pixel:
;-------------------------------------------------------------------
; ϊRA
;
		movd       xmm0, [esi]
		movd       xmm1, [esi+4]
		movd       xmm2, [eax]
		movd       xmm4, [ebx]
		movq2dq    xmm5, mm0 ; y_offset
		movq2dq    xmm6, mm1 ; c_offset
		pxor       xmm7, xmm7
		lea        esi, [esi+8]
		lea        eax, [eax+4]
		lea        ebx, [ebx+4]
		punpcklbw  xmm0, xmm7
		punpcklbw  xmm1, xmm7
		punpcklbw  xmm2, xmm7
		punpcklbw  xmm4, xmm7
		psubw      xmm0, xmm5
		psubw      xmm1, xmm5
		psubw      xmm2, xmm6
		psubw      xmm4, xmm6
		movdqa     xmm5, [esp+32] ; y_gain
		movdqa     xmm6, [esp+48] ; half_13
		movdqa     xmm3, xmm2
		punpcklwd  xmm0, xmm7
		punpcklwd  xmm1, xmm7
		punpcklwd  xmm2, xmm7
		punpcklwd  xmm3, xmm4
		punpcklwd  xmm4, xmm7
		pmaddwd    xmm0, xmm5
		pmaddwd    xmm1, xmm5
		pmaddwd    xmm2, [esp+64] ; bu
		pmaddwd    xmm3, [esp+80] ; guv
		pmaddwd    xmm4, [esp+96] ; rv
		paddd      xmm0, xmm6
		paddd      xmm1, xmm6		
		movdqa     xmm5, xmm2
		movdqa     xmm6, xmm3
		movdqa     xmm7, xmm4
		punpckldq  xmm2, xmm2
		punpckldq  xmm3, xmm3
		punpckldq  xmm4, xmm4
		punpckhdq  xmm5, xmm5
		punpckhdq  xmm6, xmm6
		punpckhdq  xmm7, xmm7
		paddd      xmm2, xmm0
		paddd      xmm3, xmm0
		paddd      xmm4, xmm0
		paddd      xmm5, xmm1
		paddd      xmm6, xmm1
		paddd      xmm7, xmm1
		psrad      xmm2, 13
		psrad      xmm3, 13
		psrad      xmm4, 13
		psrad      xmm5, 13
		psrad      xmm6, 13
		psrad      xmm7, 13
		packuswb   xmm2, xmm5 ; b
		packuswb   xmm3, xmm6 ; g
		packuswb   xmm4, xmm7 ; r
		movdqa     xmm5, xmm2 ; b'
		movdqa     xmm6, xmm3 ; g'
		movdqa     xmm7, xmm4 ; r'
		psrldq     xmm2, 1
		pslldq     xmm3, 1
		pslldq     xmm4, 1
		por        xmm7, xmm2 ; xAx7x4x1
		por        xmm5, xmm3 ; x9x6x3x0
		por        xmm6, xmm4 ; Bx8x5x2x
		pshufd     xmm7, xmm7, 11011000b ; xAx4x7x1
		pshufd     xmm5, xmm5, 11011000b ; x9x3x6x0
		pshufd     xmm6, xmm6, 11011000b ; Bx5x8x2x
		movdqa     xmm4, xmm5
		psrldq     xmm6, 2 ; xBx5x8x2
		punpcklwd  xmm5, xmm7 ; xx76xx10
		psrldq     xmm4, 8 ; xxxxx9x3
		punpckhwd  xmm7, xmm6 ; xxBAxx54
		punpcklwd  xmm6, xmm4 ; xx98xx32
		movd       [edi], xmm5
		movd       [edi+4], xmm6
		movd       [edi+8], xmm7
		psrldq     xmm5, 8
		psrldq     xmm6, 8
		psrldq     xmm7, 8
		movd       [edi+12], xmm5
		movd       [edi+16], xmm6
		movd       [edi+20], xmm7
		lea        edi, [edi+24]
;-------------------------------------------------------------------
; [vI[`FbN
		dec        ecx
		jnz        yuv422_to_bgr_next_8_pixel
;-------------------------------------------------------------------
; [
		mov        ecx, [esp+116] ; width%8*3
		test       ecx, ecx
		jz         yuv422_to_bgr_line_end
		movd       xmm0, [esi]
		movd       xmm1, [esi+4]
		movd       xmm2, [eax]
		movd       xmm4, [ebx]
		movq2dq    xmm5, mm0 ; y_offset
		movq2dq    xmm6, mm1 ; c_offset
		pxor       xmm7, xmm7
		punpcklbw  xmm0, xmm7
		punpcklbw  xmm1, xmm7
		punpcklbw  xmm2, xmm7
		punpcklbw  xmm4, xmm7
		psubw      xmm0, xmm5
		psubw      xmm1, xmm5
		psubw      xmm2, xmm6
		psubw      xmm4, xmm6
		movdqa     xmm5, [esp+32] ; y_gain
		movdqa     xmm6, [esp+48] ; half_13
		movdqa     xmm3, xmm2
		punpcklwd  xmm0, xmm7
		punpcklwd  xmm1, xmm7
		punpcklwd  xmm2, xmm7
		punpcklwd  xmm3, xmm4
		punpcklwd  xmm4, xmm7
		pmaddwd    xmm0, xmm5
		pmaddwd    xmm1, xmm5
		pmaddwd    xmm2, [esp+64] ; bu
		pmaddwd    xmm3, [esp+80] ; guv
		pmaddwd    xmm4, [esp+96] ; rv
		paddd      xmm0, xmm6
		paddd      xmm1, xmm6		
		movdqa     xmm5, xmm2
		movdqa     xmm6, xmm3
		movdqa     xmm7, xmm4
		punpckldq  xmm2, xmm2
		punpckldq  xmm3, xmm3
		punpckldq  xmm4, xmm4
		punpckhdq  xmm5, xmm5
		punpckhdq  xmm6, xmm6
		punpckhdq  xmm7, xmm7
		paddd      xmm2, xmm0
		paddd      xmm3, xmm0
		paddd      xmm4, xmm0
		paddd      xmm5, xmm1
		paddd      xmm6, xmm1
		paddd      xmm7, xmm1
		psrad      xmm2, 13
		psrad      xmm3, 13
		psrad      xmm4, 13
		psrad      xmm5, 13
		psrad      xmm6, 13
		psrad      xmm7, 13
		packssdw   xmm2, xmm5 ; b
		packssdw   xmm3, xmm6 ; g
		packssdw   xmm4, xmm7 ; r
		movdqa     xmm5, xmm2 ; b'
		movdqa     xmm6, xmm3 ; g'
		movdqa     xmm7, xmm4 ; r'
		pcmpeqw    xmm0, xmm0
		pcmpeqw    xmm1, xmm1
		psrldq     xmm2, 1
		pslldq     xmm3, 1
		pslldq     xmm4, 1
		psrld      xmm0, 16
		pslld      xmm1, 16
		por        xmm7, xmm2 ; xAx7x4x1
		por        xmm5, xmm3 ; x9x6x3x0
		por        xmm6, xmm4 ; Bx8x5x2x
		pshufd     xmm7, xmm7, 11011000b ; xAx4x7x1
		pshufd     xmm5, xmm5, 11011000b ; x9x3x6x0
		pshufd     xmm6, xmm6, 11011000b ; Bx5x8x2x
		movdqa     xmm4, xmm5
		psrldq     xmm6, 2 ; xBx5x8x2
		punpcklwd  xmm5, xmm7 ; xx76xx10
		psrldq     xmm4, 8 ; xxxxx9x3
		punpckhwd  xmm7, xmm6 ; xxBAxx54
		punpcklwd  xmm6, xmm4 ; xx98xx32
		movd       [esp+8], xmm5
		movd       [esp+12], xmm6
		movd       [esp+16], xmm7
		psrldq     xmm5, 8
		psrldq     xmm6, 8
		psrldq     xmm7, 8
		movd       [esp+20], xmm5
		movd       [esp+24], xmm6
		movd       [esp+28], xmm7
		lea        esi, [esp+8]
		rep movsb
;-------------------------------------------------------------------
; c[vI[`FbN
yuv422_to_bgr_line_end:
		mov        ecx, [esp+120]
		movd       esi, mm2
		movd       eax, mm3
		movd       ebx, mm4
		movq       mm2, mm5
		movq       mm3, mm6
		movq       mm4, mm7
		add        esi, ecx
		add        eax, ecx
		add        ebx, ecx
		mov        ecx, [esp+124]
		mov        edi, [ebp+28+12]
		movd       mm5, esi
		movd       mm6, eax
		movd       mm7, ebx
		movd       esi, mm2
		movd       eax, mm3
		movd       ebx, mm4
		add        edi, ecx
		mov        [ebp+28+12], edi
		mov        ecx,[esp+112]
		dec        edx
		jnz        yuv422_to_bgr_next_line
;-------------------------------------------------------------------
; n
		mov        esp, ebp

		pop        eax
		pop        ebx
		pop        ecx
		pop        edx
		pop        esi
		pop        edi
		pop        ebp

		ret        16
;
_yuv422_to_bgr_sse2@16 ENDP
;-------------------------------------------------------------------
; I

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; yuv422_to_yuy2_sse2 - YUV -> YUY2 ϊ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-------------------------------------------------------------------
PUBLIC              C _yuv422_to_yuy2_sse2@16
;      void __stdcall  yuv422_to_yuy2_sse2(
; [esp + 4] = FRAME                    *top,
; [esp + 8] = FRAME                    *bottom,
; [esp +12] = unsigned char            *out,
; [esp +16] = CONVERSION_PARAMETER     *prm
; )
_yuv422_to_yuy2_sse2@16 PROC
;
;-------------------------------------------------------------------
; gp郍[Jϐ
; 
; [esp+ 4] work
; [esp+36] out
; [esp+40] width/16
; [esp+44] width%16*3
; [esp+48] in_step*2
; [esp+52] out_step
; 
; total 88 + 
;-------------------------------------------------------------------
; WX^̑ޔ
		push       ebp
		push       edi
		push       esi
		push       edx
		push       ecx
		push       ebx
		push       eax
;-------------------------------------------------------------------
; x[X|C^ɃX^bNAhXL
		mov        ebp, esp
;-------------------------------------------------------------------
; [Jϐ̈̊m
		sub        esp, 88
		and        esp, 0fffffff0h
		sub        esp, 4
;-------------------------------------------------------------------
; [vp[^̍쐬
		mov        eax, [ebp+28+4]
		mov        ebx, [ebp+28+8]
		mov        edi, [ebp+28+12]
		mov        edx, [ebp+28+16]
		movd       mm0, [eax+16]
		movq       mm1, [eax+20]
		movd       mm3, [ebx+16]
		movq       mm4, [ebx+20]
		mov        eax, [edx]    ; width
		movd       mm6, [edx+8]  ; in_step
		mov        ebx, [edx+12] ; out_step
		movd       mm7, [edx+16] ; c_offset
		mov        edx, [edx+4]  ; height
		mov        ecx, eax
		mov        [esp+52], ebx ; out_step
		and        eax, 0fh      ; width%16
		shr        ecx, 4        ; width/16
		punpckldq  mm6, mm6
		punpckldq  mm7, mm7
		mov        ebx, eax
		paddd      mm3, mm6      ; bottom y + in_step
		paddd      mm4, mm6      ; bottom uv + in_step
		paddd      mm1, mm7      ; top uv + c_offset
		shl        eax, 1
		paddd      mm4, mm7      ; bottom uv + in_step + c_offset
		pslld      mm6, 1        ; in_step * 2
		add        eax, ebx      ; width%16*3
		movq       mm2, mm1
		movq       mm5, mm4
		psrlq      mm2, 32
		psrlq      mm5, 32
		mov        [esp+36], edi
		mov        [esp+40], ecx
		mov        [esp+44], eax
		movd       [esp+48], mm6
		movd       esi, mm0
		movd       eax, mm1
		movd       ebx, mm2
;-------------------------------------------------------------------
; c[v
yuv422_to_yuy2_next_line:
;-------------------------------------------------------------------
; [v
yuv422_to_yuy2_next_16_pixel:
;-------------------------------------------------------------------
; ϊRA
		movq       xmm0, [esi]
		movq       xmm1, [esi+8]
		movd       xmm4, [eax]
		movd       xmm5, [eax+4]
		movd       xmm6, [ebx]
		movd       xmm7, [ebx+4]
		lea        esi, [esi+16]
		lea        eax, [eax+8]
		lea        ebx, [ebx+8]
		punpcklbw  xmm4, xmm6
		punpcklbw  xmm5, xmm7
		punpcklbw  xmm0, xmm4
		punpcklbw  xmm1, xmm5
		movdqu     [edi], xmm0
		movdqu     [edi+16], xmm1
		lea        edi, [edi+32]
;-------------------------------------------------------------------
; [vI[`FbN
		dec        ecx
		jnz        yuv422_to_yuy2_next_16_pixel
;-------------------------------------------------------------------
; [
		mov        ecx, [esp+44]
		test       ecx, ecx
		jz         yuv422_to_yuy2_line_end
; [RA
		movq       xmm0, [esi]
		movq       xmm1, [esi+8]
		movd       xmm4, [eax]
		movd       xmm5, [eax+4]
		movd       xmm6, [ebx]
		movd       xmm7, [ebx+4]
		punpcklbw  xmm4, xmm6
		punpcklbw  xmm5, xmm7
		punpcklbw  xmm0, xmm4
		punpcklbw  xmm1, xmm5
		movdqa     [esp+4], xmm0
		movdqa     [esp+20], xmm1
		lea        esi, [esp+4]
		rep movsb
;-------------------------------------------------------------------
; c[vI[`FbN
yuv422_to_yuy2_line_end:
		mov        ecx, [esp+48]
		movd       esi, mm0
		movd       eax, mm1
		movd       ebx, mm2
		add        esi, ecx
		add        eax, ecx
		add        ebx, ecx
		mov        ecx, [esp+52]
		mov        edi, [esp+36]
		movq       mm0, mm3
		movq       mm1, mm4
		movq       mm2, mm5
		movd       mm3, esi
		movd       mm4, eax
		movd       mm5, ebx
		movd       esi, mm0
		movd       eax, mm1
		movd       ebx, mm2
		add        edi, ecx
		mov        ecx, [esp+40]
		mov        [esp+36], edi
		dec        edx
		jnz        yuv422_to_yuy2_next_line
;-------------------------------------------------------------------
; n
		mov        esp, ebp

		pop        eax
		pop        ebx
		pop        ecx
		pop        edx
		pop        esi
		pop        edi
		pop        ebp

		ret        16
;
_yuv422_to_yuy2_sse2@16 ENDP
;-------------------------------------------------------------------
; I

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; _TEXT64 ZOg̏I
END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

